#!ruby -Ks
=begin
Copyright (C) 2018 Taisuke Kobayashi
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
=end

require 'fileutils'
require 'digest/sha1'

$shuuForSeat = 6

$rootDir = '../..'
$secDir = "#$rootDir/sec"
$jigenMax = 4
$secHtmlFormat = "#$secDir/seat/%d/%02d.html"
$secSeatFormat = "#$secDir/%d-seat.csv"

# $gw = 140; $gws = 40; $gh = 70; $hs = 30; $kws = 50; $kh = 20
$gw = 145; $gws = 40; $gh = 70; $hs = 30; $kws = 50; $kh = 20

$sp1 = [8, 10, [20, 30, 50] ]
$sp2 = [8, 10, [20, 30] ]
$sp3 = [4, 12, [0, 12, 24, 36] ]
# 452l̕ό`ȋ̂߁Ãp[^͖B
# if n == 4 # 452l̕ό`ȋB
# ̃\[XQƂ̂ƁB
#$sp4 = [8, 6, [0, 6, 12, 18, 24, 30, 36, 45] ] # 0, 6, 12, 18, 24, 30, 36, 45
# if n == 14 # 452l̕ό`ȋBɂĕό`ȂɂȂ悤ɂB
$sp4 = [8, 6, [12, 18] ] # 0, 6, 12, 18, 24, 30, 36, 45

$sp = [$sp1, $sp2, $sp3, $sp4]

$html01 = "<html><head><title>"
$html02 = <<"EOS"
</title><style type="text/css">
.root {
  position: static; top: 0px; left: 0px;
}
.gakusei { 
  position: absolute;
  border: 1px solid black;
  width: #{$gw}px;
  height: #{$gh}px;
  margin: 0px 0px 0px 0px;
  padding: 0px 0px 0px 0px;
  text-align: center;
}
.kyoutaku { 
  position: absolute;
  border: 1px solid black;
  height: #{$kh}px;
  margin: 0px 0px 0px 0px;
  padding: 0px 0px 0px 0px;
  text-align: center;
}
</style></head><body><div class="root">
EOS
$html03 = "</div></body></html>\n"

def makeSeatHtml n, data
  s1 = format $secHtmlFormat, n, $shuuForSeat
  f = open s1, 'w'
  f.print $html01 + s1 + $html02
  sp = $sp[n -1]; w = sp[0]; h = sp[1]
  if n == 14 # 452l̕ό`ȋB
    1.upto 6 do |y|
      1.upto 8 do |x|
        x1 = (x -1) * $gw
        x1 += $gws * ( (x -1) /2)
        y1 = (8 -1 - (y -1) ) * $gh
        s2  = "<div class=\"gakusei\" style=\"top: #{y1}px; left: #{x1}px;\">"
        if x <= 7
          s2 += "<b>#{format '%02d', (x -1) *6 + y}</b></div>"
        else
          s2 += "<b>#{format '%02d', 6*6+8 + y}</b></div>"
        end
        f.print s2
      end
    end  
    7.upto 8 do |y|
      7.upto 8 do |x|
        x1 = (x -1) * $gw
        x1 += $gws * ( (x -1) /2)
        y1 = (8 -1 - (y -1) ) * $gh
        s2  = "<div class=\"gakusei\" style=\"top: #{y1}px; left: #{x1}px;\">"
        if x <= 7
          s2 += "<b>#{format '%02d', (x -1) *6 + y}</b></div>"
        else
          s2 += "<b>#{format '%02d', 6*6+8 + y}</b></div>"
        end
        f.print s2
      end
    end  
  else # 4ȊO̒ʏ̒`ȋB
    sno = 0
    1.upto w do |x|
      1.upto h do |y|
        x1 = (sno / h) * $gw
        x1 += $gws * ( (sno / h) /2)
        y1 = (h -1 - (sno % h) ) * $gh
        s2  = "<div class=\"gakusei\" style=\"top: #{y1}px; left: #{x1}px;\">"
        s2 += "<b>#{format '%02d', sno +1}</b></div>"
        f.print s2
        sno += 1
      end
    end  
  end
  w2 = $gw * w + $gws * (w /2 -1) - $kws *2
  x = $kws
  y = $gh * h + $hs
  if n == 14 # 452l̕ό`ȋB
    y = $gh * 8 + $hs
  end
  s2  = "<div class=\"kyoutaku\" style=\"top: #{y}px; left: #{x}px; width: #{w2}px\">"
  s2 += "</div>\n"
  f.print s2
  spa = sp[2]
  spn = spa.size
  i = 0
  data.each do |v|
    sno = spa[i % spn] + (i / spn)
    x = (sno / h) * $gw
    x += $gws * ( (sno / h) /2)
    y = (h -1 - (sno % h) ) * $gh
    if n == 14 # 452l̕ό`ȋB
      # 6 6 6 6 6 6 8 8 =52
      i = 54 if i == 48
      i = 62 if i == 56
      x = (i % 8) * $gw
      x += $gws * ( (i % 8) /2)
      y = (8 -1 - (i / 8) ) * $gh
    end
    s2  = "<div class=\"gakusei\" style=\"top: #{y}px; left: #{x}px; border: none\">"
    s2 += "<br>"
    s3 = v[3]
    s4 = '  '
    s4[0] = s3[0] if s3.size > 1
    s4[1] = s3[1] if s3.size > 2
    s4[1] = ' ' if s4[1] == '-'  
    s2 += "#{v[1]} #{s4} #{v[2]}<br>"
    s2 += "#{v[0]} #{v[4]}</div>\n"
    #s2 += "#{v[0]} #{v[4]} #{v[5]}</div>\n"
    f.print s2 if v[5] != '0'
    i += 1
    if n == 4
      if i >= 24
        break
      end
    end
  end
  f.print $html03
  f.close
end

def sortData data
  data.each do |a|
    a[4] = '999' if a[5] == '0'
  end
  data.sort! do |a, b|
    a3 = a[3][0, 1]; b3 = b[3][0, 1]; 
    if a3 < b3; -1; elsif a3 > b3; 1; else
      a4 = a[4].to_i; b4 = b[4].to_i
      if a4 < b4; -1; elsif a4 > b4; 1; else
        0
      end
    end
  end
end

=begin

def sortData data
  data.sort! do |a, b|
    a3 = a[3][0, 4]; b3 = b[3][0, 4]; 
    if a3 < b3; -1; elsif a3 > b3; 1; else
      a2 = a[2].to_i; b2 = b[2].to_i
      if a2 > b2; -1; elsif a2 < b2; 1; else
        #a4 = a[4].to_i; b4 = b[4].to_i
        a4 = a[0]; b4 = b[0]
        if a4 < b4; -1; elsif a4 > b4; 1; else
          0
        end
      end
    end
  end
end

=end

def readSeatCsv n, data
  IO.foreach format($secSeatFormat, n) do |line|
    if line =~ /^(\d{2}-\w{5}),([^,]+),(\d+),([^,]+),([\d-]+),(\d+)/
      gno = $1; name = $2; shusseki = $3; kadai = $4; chikoku = $5; gaikadai_n = $6
      data.push [gno, name, shusseki, kadai, chikoku, gaikadai_n]
    end
  end
end

def jigen n
  data = []
  readSeatCsv n, data
  sortData data
  makeSeatHtml n, data
end

1.upto $jigenMax do |n|
  jigen n
end
